﻿Imports System.IO
Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            Using conn As SqlConnection = New SqlConnection(constr)
                Using sda As SqlDataAdapter = New SqlDataAdapter("SELECT * FROM tblFiles", conn)
                    Dim dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    gvImages.DataSource = dt
                    gvImages.DataBind()
                End Using
            End Using
        End If
    End Sub

    Protected Sub OnRowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim dr As DataRowView = CType(e.Row.DataItem, DataRowView)
            Dim imageUrl As String = "data:image/jpg;base64," & Convert.ToBase64String(CType(dr("Data"), Byte()))
            CType(e.Row.FindControl("Image1"), Image).ImageUrl = imageUrl
        End If
    End Sub

    Protected Sub Upload(ByVal sender As Object, ByVal e As EventArgs)
        Dim bytes As Byte()
        Using br As BinaryReader = New BinaryReader(fuUpload.PostedFile.InputStream)
            bytes = br.ReadBytes(fuUpload.PostedFile.ContentLength)
        End Using

        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using conn As SqlConnection = New SqlConnection(constr)
            Dim sql As String = "INSERT INTO tblFiles VALUES(@Name, @ContentType, @Data)"
            Using cmd As SqlCommand = New SqlCommand(sql, conn)
                cmd.Parameters.AddWithValue("@Name", Path.GetFileName(fuUpload.PostedFile.FileName))
                cmd.Parameters.AddWithValue("@ContentType", fuUpload.PostedFile.ContentType)
                cmd.Parameters.AddWithValue("@Data", bytes)
                conn.Open()
                cmd.ExecuteNonQuery()
                conn.Close()
            End Using
        End Using

        Response.Redirect(Request.Url.AbsoluteUri)
    End Sub
End Class
